#include "ScalarConverter.hpp"

#include <cctype>
#include <cerrno>
#include <cmath>
#include <cstdlib>
#include <cstddef>
#include <exception>
#include <iostream>
#include <string>

#include <float.h>
#include <limits.h>
#include <string.h>
#include <math.h>

ScalarConverter::ScalarConverter()
{}

ScalarConverter::ScalarConverter(const ScalarConverter& src)
{
	(void) src;
}

ScalarConverter::~ScalarConverter()
{}

ScalarConverter& ScalarConverter::operator=(const ScalarConverter& src)
{
	if (this != &src)
		*this = src;
	return *this;
}

double get_value(const std::string& str)
{
	char *pos;
	if (str.length() == 3 && str[0] == '\'' && str[2] == '\'')
		return str[1];
	double value = std::strtod(str.c_str(), &pos);
	if (errno == ERANGE || (pos[0] != '\0' && strcmp(pos, "f")))
		throw std::exception();
	return value;
}

void convert2char(const double value)
{
	std::cout << "char: ";
	if (value > CHAR_MAX || CHAR_MIN > value)
		std::cout << "imposible";
	else if (isprint(static_cast<char>(value)))
		std::cout << static_cast<char>(value);
	else
		std::cout << "Non displayable";
	std::cout << std::endl;
}

void convert2int(const double value)
{
	std::cout << "int: ";
	if (value > INT_MAX || INT_MIN > value)
		std::cout << "imposible";
	else
		std::cout << static_cast<int>(value);
	std::cout << std::endl;
}

void convert2float(const double value)
{
	std::cout << "float: ";
	if ((value > FLT_MAX || FLT_MIN > value) && !std::isinf(value))
		std::cout << "imposible";
	else
		std::cout << static_cast<float>(value) << "f";
	std::cout << std::endl;
}

void ScalarConverter::convert(const std::string &str)
{
	double value;
	try {
		value = get_value(str);
	} catch (std::exception &e) {
		std::cout << "convert imposible" << std::endl;
		return;
	}
	convert2char(value);
	convert2int(value);
	convert2float(value);
	std::cout << "double: " << value << std::endl;
}
