#include "identify.hpp"
#include "A.hpp"
#include "B.hpp"
#include "C.hpp"

#include <exception>
#include <iostream>
#include <stddef.h>

void identify(Base* p)
{
	if (dynamic_cast<A*>(p) != NULL)
		std::cout << "A" << std::endl;
	else if (dynamic_cast<B*>(p) != NULL)
		std::cout << "B" << std::endl;
	else if (dynamic_cast<C*>(p) != NULL)
		std::cout << "C" << std::endl;
}

void identify(const Base &r)
{
	try
	{
		(void)dynamic_cast<const A&>(r);
		std::cout << "A" << std::endl;
		return;
	}
	catch (std::exception& e) {}
	try
	{
		(void)dynamic_cast<const B&>(r);
		std::cout << "B" << std::endl;
		return;
	}
	catch (std::exception& e) {}
	try
	{
		(void)dynamic_cast<const C&>(r);
		std::cout << "C" << std::endl;
		return;
	}
	catch (std::exception& e) {}
}
